// PSY-O-BLADE(PC-98/2HD) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*8*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	unsigned char id[] = "PSYOBLADE ";

	struct fpos md[] =
	{
		{ 0x0f, 0x01, 0x0000, 0x1000 },
		{ 0x0f, 0x05, 0x0000, 0x0800 },
		{ 0x0f, 0x07, 0x0000, 0x0380 },
		{ 0x0f, 0x07, 0x0380, 0x0300 },
		{ 0x0f, 0x08, 0x0280, 0x0380 },
		{ 0x10, 0x01, 0x0200, 0x0680 },
		{ 0x10, 0x03, 0x0080, 0x0280 },
		{ 0x10, 0x03, 0x0300, 0x0280 },
		{ 0x10, 0x04, 0x0180, 0x0180 },
		{ 0x10, 0x04, 0x0300, 0x0100 },
		{ 0x10, 0x05, 0x0000, 0x0300 },
		{ 0x10, 0x05, 0x0300, 0x0180 },
		{ 0x10, 0x06, 0x0080, 0x0200 },
		{ 0x10, 0x06, 0x0280, 0x0580 },
		{ 0x10, 0x08, 0x0000, 0x0280 },
		{ 0x10, 0x08, 0x0280, 0x0200 },
		{ 0x00, 0x00, 0x0000, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x08);
		disk.ReadDATA1(0x01, 0x00, 0x01, 0x01, 0x03, buff, 0x400);
		if (!memcmp(&buff[0x3f0],id,sizeof(id)-1))
		{
			switch(buff[0x3fc])
			{
				case 'A':
					printf("Program Disk F܂.\n");
					fcut("PROG", 0x02, 0x01, 0x00, 0x01, 0x03, 0x0000, 0x3c00);
					break;
				case 'B':
					printf("Data Disk F܂.\n");
					for (i=0; md[i].sec; i++)
					{
						sprintf(fname,"MUS%02d",i);
						fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x03, md[i].ofs, md[i].size);
					}
					break;
				case 'U':
					printf("User Disk F܂.\n");
					break;
			}
		}
	}
	return 0;
}

